# coding: utf-8

"""
    ABX Service - APIs

    Create or manage actions and their versions. Execute actions and flows.  This page describes the RESTful APIs for ABX Service. The APIs facilitate CRUD operations on creation and management of Actions and their Versions and also allow Execution of Actions and Flows.  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across ABX Service APIs.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/abx/api/resources/actions?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/abx/api/resources/actions?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/abx/api/resources/actions?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /abx/api/resources/actions?$filter=startswith(name, 'ABC')     /abx/api/resources/actions?$filter=toupper(name) eq 'ABCD-ACTION'     /abx/api/resources/actions?$filter=substringof(%27bc%27,tolower(name))     /abx/api/resources/actions?$filter=name eq 'ABCD' and actionType eq 'SCRIPT'   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ActionsImport(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'bundle_id': 'str',
        'compressed_bundle': 'list[str]',
        'option': 'str',
        'project_id': 'str',
        'system': 'bool'
    }

    attribute_map = {
        'bundle_id': 'bundleId',
        'compressed_bundle': 'compressedBundle',
        'option': 'option',
        'project_id': 'projectId',
        'system': 'system'
    }

    def __init__(self, bundle_id=None, compressed_bundle=None, option=None, project_id=None, system=None):  # noqa: E501
        """ActionsImport - a model defined in Swagger"""  # noqa: E501
        self._bundle_id = None
        self._compressed_bundle = None
        self._option = None
        self._project_id = None
        self._system = None
        self.discriminator = None
        if bundle_id is not None:
            self.bundle_id = bundle_id
        if compressed_bundle is not None:
            self.compressed_bundle = compressed_bundle
        if option is not None:
            self.option = option
        if project_id is not None:
            self.project_id = project_id
        if system is not None:
            self.system = system

    @property
    def bundle_id(self):
        """Gets the bundle_id of this ActionsImport.  # noqa: E501


        :return: The bundle_id of this ActionsImport.  # noqa: E501
        :rtype: str
        """
        return self._bundle_id

    @bundle_id.setter
    def bundle_id(self, bundle_id):
        """Sets the bundle_id of this ActionsImport.


        :param bundle_id: The bundle_id of this ActionsImport.  # noqa: E501
        :type: str
        """

        self._bundle_id = bundle_id

    @property
    def compressed_bundle(self):
        """Gets the compressed_bundle of this ActionsImport.  # noqa: E501


        :return: The compressed_bundle of this ActionsImport.  # noqa: E501
        :rtype: list[str]
        """
        return self._compressed_bundle

    @compressed_bundle.setter
    def compressed_bundle(self, compressed_bundle):
        """Sets the compressed_bundle of this ActionsImport.


        :param compressed_bundle: The compressed_bundle of this ActionsImport.  # noqa: E501
        :type: list[str]
        """

        self._compressed_bundle = compressed_bundle

    @property
    def option(self):
        """Gets the option of this ActionsImport.  # noqa: E501


        :return: The option of this ActionsImport.  # noqa: E501
        :rtype: str
        """
        return self._option

    @option.setter
    def option(self, option):
        """Sets the option of this ActionsImport.


        :param option: The option of this ActionsImport.  # noqa: E501
        :type: str
        """
        allowed_values = ["FAIL", "IGNORE", "OVERWRITE", "CREATE"]  # noqa: E501
        if option not in allowed_values:
            raise ValueError(
                "Invalid value for `option` ({0}), must be one of {1}"  # noqa: E501
                .format(option, allowed_values)
            )

        self._option = option

    @property
    def project_id(self):
        """Gets the project_id of this ActionsImport.  # noqa: E501


        :return: The project_id of this ActionsImport.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this ActionsImport.


        :param project_id: The project_id of this ActionsImport.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def system(self):
        """Gets the system of this ActionsImport.  # noqa: E501


        :return: The system of this ActionsImport.  # noqa: E501
        :rtype: bool
        """
        return self._system

    @system.setter
    def system(self, system):
        """Sets the system of this ActionsImport.


        :param system: The system of this ActionsImport.  # noqa: E501
        :type: bool
        """

        self._system = system

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ActionsImport, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ActionsImport):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
